package de.mdelab.mlexpressions.ui.ocl;

import java.util.Map;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.jface.text.source.IVerticalRuler;
import org.eclipse.jface.text.source.SourceViewer;
import org.eclipse.swt.widgets.Composite;

public class OCLSourceViewer extends SourceViewer {
	
	public OCLSourceViewer(	final Composite parent,
							final IVerticalRuler ruler,
							final int styles,
							final ColorManager colorManager, 
							final EClassifier contextClassifier,
							final Map<String, EClassifier> contextInformation, 
							final String text ) {
		super(parent, ruler, styles);

		OCLDocument oclDocument = new OCLDocument();
		oclDocument.set(text);
		oclDocument.setOCLContext(contextClassifier);
		oclDocument.setOCLContextInformation(contextInformation);

		setDocument(oclDocument);

		configure(new OCLSourceViewerConfiguration(colorManager, oclDocument));
	}
}
